// (c)2002 SkyJet's definition software :)))
// Buryuminu no arugorizumu wa amari yoi arimasen ^_~

#include "stdafx.h"
#include <conio.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

double f(double x) {

	return sqrt(x*x+4); //insert your function here
}

void calc(double *a, double *b, double *c, double *s, double *x, int n)
{
  double *k = new double[n];
  double *p = new double[n];
  double r;
  int i;
  k[1] = - c[1] / b[1];
   p[1] = s[1] / b[1];
   for (i = 2; i<=n; i++)
   {
      r = a[i] * k[i-1] + b[i];
      k[i] = - c[i] / r;
      p[i] = (s[i] - a[i] * p[i-1]) / r;
   }
   x[n-1] = p[n-1];
   for (i = n-1; i>=1; i--)
   {
      
	   x[i-1] = k[i] * x[i] + p[i];
   }

}

void tab_func(double *y, double a, double b, int n) {
	double h = (b - a)/n;
	for (int i=0; i < n; i++){
		y[i] = f(a + h*i);
	}
}

void bld_spln(double *y, double *m, double *p, double *q, double *r, double h, int n){
	for (int i=0; i < n; i++){
		m[i] = y[i];
		p[i] = (y[i+1]-y[i])/h - (h/3)*(q[i+1]+2*q[i]);
		r[i] = (q[i+1] - q[i])/(3*h);
	}
}

void bld_matrix(double *y, double *a, double *b, double *c, double *s, double h, int n) {

	for (int i=1; i < n; i++){
		a[i+1] = 1;
		b[i+1] = 4;
		c[i+1] = 1;
	    s[i+1] = 3*(y[i-1] - 2*y[i] + y[i+1])/(h*h);
		a[1] = 0;
		c[n-1] = 0;
	}
}

void get_spline(double *y, double *m, double *p, double *q, double *r, double bl, double el, int n) {
   double *a = new double[n];
   double *b = new double[n];
   double *c = new double[n];
   double *s = new double[n];
   double h = (bl - el)/n;
   bld_matrix(y, a, b, c, s, h, n);
   calc(a, b, c, s, q, n);
   bld_spln(y, m, p, q, r, h, n);
}

double spf_calc(double *m, double *p, double *q, double *r, double a, double b, double x, int n){
	double h = (b - a)/n;
	int i = 0;
	if (x > 0 && a < 0) {
		while((a+h*i)<0) {
			i++;
		}
	}
	while(x > (a+h*i)) {
		i++;
	}

	return m[i] + p[i]*(x - a - h*i) + q[i]*pow((x - a - h*i),2) + pow((x - a - h*i),3);
}

void main(int argc, char* argv[])
{
   //int n;
   //printf("Input number of steps: ");
   //scanf("%d", &n);
   const n=10; //number of steps
   int i;
   double a = -1, b = 2, x; //your function's determination area
   double *y = new double[n];
   double *m = new double[n];
   double *p = new double[n];
   double *q = new double[n];
   double *r = new double[n];

   tab_func(y, a, b, n);
   get_spline(y, m, p, q, r, a, b, n);

   printf("Coefficients of spline's polynom:\n\n");
   printf("%10s %10s %10s %10s\n", "M   ", "P   ", "Q    ", "R   ");
   for(i=0; i<n; i++)
   {
	   printf("%10f %10f %10f %10f\n", m[i], p[i], q[i], r[i]);
   }
   printf("\nResult:\n\n");
   printf("%10s %10s %10s %10s\n", "f(x) ", "S(x)  ", "Abs  ", "Rel  ");
   double h = (b - a)/n, val, abs;
   for(i=0; i<n-1; i++)
   {      
	   x = a + h*(i-0.5);
	   val = spf_calc(m ,p, q, r, a, b, x, n);
	   abs = y[i] - val;
	   printf("%10f %10f %10f %10f%%\n", y[i], val, abs, fabs(abs/val)*100);
   }
   printf("\nInput the test value (type 77 if you want to exit).\n");
   float x1;
   while(1){
       printf("\n> ");
	   scanf("%f", &x1);
	   if(x1==77) break;
	   if(x1 < a || x1 > b) printf("Illegal value. It must be placed at defined area (%f,%f)\n", a, b);
		   else {
		   x = x1;
		   val = spf_calc(m ,p, q, r, a, b, x, n);
		   abs = f(x) - val;
		   printf("%10f %10f %10f %10f%%\n", f(x), val, abs, fabs(abs/val)*100);
	   }
   }
   return;
}
